{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#histogram_shape.cwl/inputfile"
                },
                {
                    "type": "string",
                    "id": "#histogram_shape.cwl/name"
                },
                {
                    "type": "string",
                    "id": "#histogram_shape.cwl/shapevar"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#histogram_shape.cwl/variations"
                },
                {
                    "type": "float",
                    "id": "#histogram_shape.cwl/weight"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "source /usr/local/bin/thisroot.sh\npython /code/histogram.py $(inputs.inputfile.path) hist.root $(inputs.name)_$(inputs.shapevar) $(inputs.weight) ${\n  var list=\"\";\n  var variationsLength = inputs.variations.length;\n  console.log(variationsLength);\n  for (var i = 0; i < variationsLength; i++) {\n    list += inputs.variations[i];\n    if (i < variationsLength - 1) {\n      list = list +\",\";\n    }\n  }\n  return list; } {name}\n"
                }
            ],
            "id": "#histogram_shape.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "hist.root"
                    },
                    "id": "#histogram_shape.cwl/histogram"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#select.cwl/inputfile"
                },
                {
                    "type": "string",
                    "id": "#select.cwl/region"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#select.cwl/variations"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "selection.root"
                    },
                    "id": "#select.cwl/outputfile"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "source /usr/local/bin/thisroot.sh\npython /code/select.py $(inputs.inputfile.path) selection.root $(inputs.region) ${\n   var list=\"\";\n   var variationsLength = inputs.variations.length;\n   console.log(variationsLength);\n   for (var i = 0; i < variationsLength; i++) {\n     list += inputs.variations[i];\n     if (i < variationsLength - 1) {\n       list = list +\",\";\n     }\n   }\n   return list; }\n"
                }
            ],
            "id": "#select.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/inputfile"
                },
                {
                    "type": "string",
                    "id": "#main/mcname"
                },
                {
                    "type": "float",
                    "id": "#main/mcweight"
                },
                {
                    "type": "string",
                    "id": "#main/shapevar"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/hist/histogram",
                    "id": "#main/histogram"
                }
            ],
            "steps": [
                {
                    "run": "#histogram_shape.cwl",
                    "in": [
                        {
                            "source": "#main/select/outputfile",
                            "id": "#main/hist/inputfile"
                        },
                        {
                            "source": "#main/mcname",
                            "id": "#main/hist/name"
                        },
                        {
                            "source": "#main/shapevar",
                            "id": "#main/hist/shapevar"
                        },
                        {
                            "default": [
                                "nominal"
                            ],
                            "id": "#main/hist/variations"
                        },
                        {
                            "source": "#main/mcweight",
                            "id": "#main/hist/weight"
                        }
                    ],
                    "out": [
                        "#main/hist/histogram"
                    ],
                    "id": "#main/hist"
                },
                {
                    "run": "#select.cwl",
                    "in": [
                        {
                            "source": "#main/inputfile",
                            "id": "#main/select/inputfile"
                        },
                        {
                            "default": "signal",
                            "id": "#main/select/region"
                        },
                        {
                            "source": "#main/shapevar",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/select/variations"
                        }
                    ],
                    "out": [
                        "#main/select/outputfile"
                    ],
                    "id": "#main/select"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
